/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 * 
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 * 
 * Project Info:   http://descartes.tools/dql
 * 
 * All rights reserved. This software is made available under the terms of the 
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org 
 * 
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.lang.descartesQL;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Goal</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.Goal#getQueryType <em>Query Type</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.Goal#getSlaQuery <em>Sla Query</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.Goal#getSloQuery <em>Slo Query</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.Goal#getForClause <em>For Clause</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.Goal#getUsingClause <em>Using Clause</em>}</li>
 * </ul>
 *
 * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getGoal()
 * @model
 * @generated
 */
public interface Goal extends EObject
{
  /**
   * Returns the value of the '<em><b>Query Type</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Query Type</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Query Type</em>' attribute.
   * @see #setQueryType(String)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getGoal_QueryType()
   * @model
   * @generated
   */
  String getQueryType();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.Goal#getQueryType <em>Query Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Query Type</em>' attribute.
   * @see #getQueryType()
   * @generated
   */
  void setQueryType(String value);

  /**
   * Returns the value of the '<em><b>Sla Query</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Sla Query</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Sla Query</em>' containment reference.
   * @see #setSlaQuery(SlaQuery)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getGoal_SlaQuery()
   * @model containment="true"
   * @generated
   */
  SlaQuery getSlaQuery();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.Goal#getSlaQuery <em>Sla Query</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Sla Query</em>' containment reference.
   * @see #getSlaQuery()
   * @generated
   */
  void setSlaQuery(SlaQuery value);

  /**
   * Returns the value of the '<em><b>Slo Query</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Slo Query</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Slo Query</em>' containment reference.
   * @see #setSloQuery(SloQuery)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getGoal_SloQuery()
   * @model containment="true"
   * @generated
   */
  SloQuery getSloQuery();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.Goal#getSloQuery <em>Slo Query</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Slo Query</em>' containment reference.
   * @see #getSloQuery()
   * @generated
   */
  void setSloQuery(SloQuery value);

  /**
   * Returns the value of the '<em><b>For Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>For Clause</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>For Clause</em>' containment reference.
   * @see #setForClause(ForClause)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getGoal_ForClause()
   * @model containment="true"
   * @generated
   */
  ForClause getForClause();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.Goal#getForClause <em>For Clause</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>For Clause</em>' containment reference.
   * @see #getForClause()
   * @generated
   */
  void setForClause(ForClause value);

  /**
   * Returns the value of the '<em><b>Using Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Using Clause</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Using Clause</em>' containment reference.
   * @see #setUsingClause(UsingClause)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getGoal_UsingClause()
   * @model containment="true"
   * @generated
   */
  UsingClause getUsingClause();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.Goal#getUsingClause <em>Using Clause</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Using Clause</em>' containment reference.
   * @see #getUsingClause()
   * @generated
   */
  void setUsingClause(UsingClause value);

} // Goal
