/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 * 
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 * 
 * Project Info:   http://descartes.tools/dql
 * 
 * All rights reserved. This software is made available under the terms of the 
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org 
 * 
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.lang.descartesQL;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Sla Query</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.SlaQuery#getType <em>Type</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.SlaQuery#getSlas <em>Slas</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.SlaQuery#getSloa <em>Sloa</em>}</li>
 * </ul>
 *
 * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getSlaQuery()
 * @model
 * @generated
 */
public interface SlaQuery extends EObject
{
  /**
   * Returns the value of the '<em><b>Type</b></em>' attribute.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Type</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Type</em>' attribute.
   * @see #setType(String)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getSlaQuery_Type()
   * @model
   * @generated
   */
  String getType();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.SlaQuery#getType <em>Type</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Type</em>' attribute.
   * @see #getType()
   * @generated
   */
  void setType(String value);

  /**
   * Returns the value of the '<em><b>Slas</b></em>' containment reference list.
   * The list contents are of type {@link tools.descartes.dql.lang.descartesQL.Sla}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Slas</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Slas</em>' containment reference list.
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getSlaQuery_Slas()
   * @model containment="true"
   * @generated
   */
  EList<Sla> getSlas();

  /**
   * Returns the value of the '<em><b>Sloa</b></em>' containment reference list.
   * The list contents are of type {@link tools.descartes.dql.lang.descartesQL.Sla}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Sloa</em>' containment reference list isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Sloa</em>' containment reference list.
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getSlaQuery_Sloa()
   * @model containment="true"
   * @generated
   */
  EList<Sla> getSloa();

} // SlaQuery
