/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 *
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 *
 * Project Info:   http://descartes.tools/dql
 *
 * All rights reserved. This software is made available under the terms of the
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 *
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org
 *
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.pavo.result;

import tools.descartes.dql.models.mapping.domain.Result;

public abstract class AbstractQuantitativeResult {
	private String queryableElement; // e.g., CPU1 has Type CPU
	private String metric; // e.g., TIME
	private String StatisticType; // series OR aggregated value
	// series
	// aggregates value, davon erben mean, max, min usw
	private String scale; // for values
	private Result resultLocation=null;
	private int DotsShown = 0;
	
	//Constructor for Series 
	public AbstractQuantitativeResult(String queryableElementN, String metricN, String statisticTypeN, String scaleN, Result resultLocationNeu)
	{
		queryableElement=queryableElementN;
		metric = metricN;
		StatisticType = statisticTypeN;
		scale = scaleN;
		resultLocation = resultLocationNeu;
	}
	
	//Constructor for String and Value 
	public AbstractQuantitativeResult(String queryableElementN, String metricN, String statisticTypeN, String scaleN)
	{
		queryableElement=queryableElementN;
		metric = metricN;
		StatisticType = statisticTypeN;
		scale = scaleN;
		resultLocation = null;
	}
	
	
	
	
	
	
	/**
	 * @return the dotsShown
	 */
	public int getDotsShown() {
		return DotsShown;
	}

	/**
	 * @param dotsShown the dotsShown to set
	 */
	public void setDotsShown(int dotsShown) {
		DotsShown = dotsShown;
	}

	/**
	 * @return the resultLocation
	 */
	public Result getResultLocation() {
		return resultLocation;
	}






	/**
	 * @param resultLocation the resultLocation to set
	 */
	public void setResultLocation(Result resultLocation) {
		this.resultLocation = resultLocation;
	}






	/**
	 * @return the queryableElement
	 */
	public String getQueryableElement() {
		return queryableElement;
	}
	/**
	 * @param queryableElement the queryableElement to set
	 */
	public void setQueryableElement(String queryableElement) {
		this.queryableElement = queryableElement;
	}
	/**
	 * @return the metric
	 */
	public String getMetric() {
		return metric;
	}
	/**
	 * @param metric the metric to set
	 */
	public void setMetric(String metric) {
		this.metric = metric;
	}
	/**
	 * @return the statisticType
	 */
	public String getStatisticType() {
		return StatisticType;
	}
	/**
	 * @param statisticType the statisticType to set
	 */
	public void setStatisticType(String statisticType) {
		StatisticType = statisticType;
	}
	/**
	 * @return the scale
	 */
	public String getScale() {
		return scale;
	}
	/**
	 * @param scale the scale to set
	 */
	public void setScale(String scale) {
		this.scale = scale;
	}
	
	
}
